<template>
  <CModal
    :show.sync="show"
    :centered="false"
    :close-on-backdrop="false"
    size="lg"
    class="modal-form event-detail-modal"
  >
    <template #header>
      <h6 class="modal-title">
        {{ form.id ? 'Event detail' : 'Create new event' }}
      </h6>
      <CButtonClose @click="onClose" />
    </template>

    <CForm>
      <CCard>
        <CCardBody>
          <p>Title: <input v-model="form.title" type="text" placeholder="Title" class="form-control"></p>
          <p>Start: <input v-model="form.start" type="text" placeholder="Start" class="form-control"></p>
          <p>End: <input v-model="form.end" type="text" placeholder="End" class="form-control"></p>
        </CCardBody>
        <CCardFooter>
          <CButton
            color="primary"
            @click="onCreate"
          >
            <font-awesome-icon :icon="['fas', 'save']" />
            Save
          </CButton>

          <CButton
            v-if="form.id"
            color="danger"
            @click="onDelete"
          >
            <font-awesome-icon :icon="['fas', 'trash-alt']" />
            Delete
          </CButton>
          <CButton color="secondary" @click="onClose">
            Cancel
          </CButton>
        </CCardFooter>
      </CCard>
    </CForm>

    <template #footer>
      <span />
    </template>
  </CModal>
</template>

<script>
export default {
  props: {
    show: {
      type: Boolean,
      default: false
    },

    event: {
      type: Object,
      default: () => {}
    }
  },

  computed: {
    form () {
      const data = Object.assign({}, this.event)

      return data
    }
  },

  methods: {
    onCreate () {
      this.$emit('create', this.form)
    },

    onDelete () {
      this.$emit('delete', +this.form.id)
    },

    onClose () {
      this.$emit('close')
    }

  }
}
</script>
